﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.UI;

namespace _1150876_ListviewCustomitems
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent();
            this.radListView1.VisualItemCreating += radListView1_VisualItemCreating;

            List<Item> items = new List<Item>();
            items.Add(new Item(1000459,345,"item1","Lorem ipsum dolor sit amet, consectetur adipiscing elit. END"));
            items.Add(new Item(1055949, 355, "item2", "Aenean ullamcorper posuere neque, ac fringilla ante. Vestibulum commodo dignissim molestie. Phasellus vitae nisi ac nisl aliquam interdum vel eu nulla. Aenean sed quam vitae libero pretium sodales. Integer felis lorem, facilisis id pellentesque a, auctor sit amet mi. END"));
            this.radListView1.DataSource = items;

            this.radListView1.AllowArbitraryItemHeight = true;
            this.radListView1.AllowEdit = false;
        }

        private void radListView1_VisualItemCreating(object sender, ListViewVisualItemCreatingEventArgs e)
        {
            if (this.radListView1.ViewType == ListViewType.ListView)
            {
                e.VisualItem = new RuleVisualItem();
            }
        }

        public class RuleVisualItem : SimpleListViewVisualItem
        {
            private RadTextBoxControlElement _idElement;
            private RadTextBoxControlElement _sequenceElement;
            private RadTextBoxControlElement _nameElement;
            private RadTextBoxControlElement _ruleTextElement;
            private LightVisualElement _contentElement;
            private StackLayoutPanel _vStackLayout;
            private StackLayoutPanel _stackLayout;
 
            protected override void CreateChildElements()
            {
                base.CreateChildElements();
 
                _stackLayout = new StackLayoutPanel
                {
                    Orientation = Orientation.Horizontal,
                    //AutoSize = true,
                    EqualChildrenWidth = true,
                    ShouldHandleMouseInput = false,
                    NotifyParentOnMouseInput = true
                };
 
                _vStackLayout = new StackLayoutPanel
                {
                    Orientation = Orientation.Vertical,
                    ShouldHandleMouseInput = false,
                    NotifyParentOnMouseInput = true
                };
 
                _contentElement = new LightVisualElement
                {
                    StretchHorizontally = true,
                    MinSize = new Size(120, 0),
                    ShouldHandleMouseInput = false,
                    NotifyParentOnMouseInput = true
                };
                _idElement = new RadTextBoxControlElement { Text = "", MinSize = new Size(120, 0) };
                _idElement.IsReadOnly = true;
                _stackLayout.Children.Add(_idElement);
 
                _sequenceElement = new RadTextBoxControlElement { Text = "" };
                _sequenceElement.IsReadOnly = true;
                _stackLayout.Children.Add(_sequenceElement);
 
                _nameElement = new RadTextBoxControlElement { Text = "" };
                _nameElement.IsReadOnly = true;
                _stackLayout.Children.Add(_nameElement);
 
                // _stackLayout.Children.Add(_contentElement);
 
                _ruleTextElement = new RadTextBoxControlElement
                {
                    Text = "",
                    Multiline=true
                    //ShouldHandleMouseInput = false,
                    //NotifyParentOnMouseInput = true,
                };
 
                _vStackLayout.Children.Add(_stackLayout);
                _vStackLayout.Children.Add(_ruleTextElement);
 
                Children.Add(_vStackLayout);
            }
 
            protected override void SynchronizeProperties()
            {
                base.SynchronizeProperties();
 
                Text = "";
                _contentElement.Text = "";
                _idElement.Text = Convert.ToString(Data["RuleItemId"]);
                _sequenceElement.Text = Convert.ToString(Data["Sequence"]);
                _nameElement.Text = Convert.ToString(Data["Name"]);
                _ruleTextElement.Text = Convert.ToString(Data["RuleItemText"]);
            }
 
            protected override Type ThemeEffectiveType
            {
                get
                {
                    return typeof(SimpleListViewVisualItem);
                }
            }
        }

        public class Item
        {
            public int RuleItemId { get; set; }

            public int Sequence { get; set; }

            public string Name { get; set; }

            public string RuleItemText { get; set; }

            public Item(int ruleItemId, int sequence, string name, string ruleItemText)
            {
                this.RuleItemId = ruleItemId;
                this.Sequence = sequence;
                this.Name = name;
                this.RuleItemText = ruleItemText;
            }
        }
    }
}